#include <stdio.h>
#include <ctype.h>

/***********************************************************************
 * main()
 * 
 * First print the file, then print it with whitespace compressed.
 ***********************************************************************/

int main(void) {

	char	fileName[FILENAME_MAX+1];	// symbol from <stdio.h>
	FILE*	inFile;
	char	nextChar;
	int		status;

	printf("Enter filename: ");
	scanf("%s", fileName);				// errors are "basically impossible"

	// first print "as is"

	inFile = fopen(fileName, "r");
	if (inFile==NULL) {
		printf ("Couldn't open file %s\n", fileName);
		return -1;
	}

	while (fscanf(inFile, "%c", &nextChar) != EOF) {
		printf("%c", nextChar);
	}

	fclose(inFile);

	printf ("\n*************************************************************\n");
	printf("Press any key to continue: ");
	scanf(" %c", &nextChar);

	// now print with compressed spaces

	inFile = fopen(fileName, "r");
	if (inFile==NULL) {
		printf("Weird, couldn't open file %s second time\n", fileName);
		return -1;
	}

	do {
		// print token
		while ((status=fscanf(inFile, "%c", &nextChar))!= EOF && !isspace(nextChar)) {
			printf ("%c", nextChar);
		}

		// print a space
		if (status != EOF) printf (" ");

		// skip white space
		while (status!=EOF && isspace(nextChar) && nextChar != '\n') {
			status = fscanf(inFile, "%c", &nextChar);
		}
		if (status != EOF) printf ("%c", nextChar);	// What's this line for?

	} while (status != EOF);
	fclose(inFile);

	return 0;
}
